loadfile("luaScripts/screen_reader_common.inc")();
loadfile("luaScripts/ui_utils.inc")();

-- Fix this for your own crematory!
mapping = {{3}, {2}, {4,6}, {5}, {1,7}};



window_w = 330;
window_h = 400;
tol=6000;

gauge_middle = -68;
gauges = {-10, 26, 62, 98, 134, 170, 206};
gauge_range = 65;

button_middle = 12;
buttons = {20, 60, 100, 140, 180};

red_spot_x = -3;
red_spot_y = -158;

function isRed(color)
	-- TODO: implement
	return true;
end

function getTemps(origin)

	local readings = {};
	for gauge = 1,7 do
				 
		local pos = srFindImageInRange("CrematoryIndicator.png", origin[0]+gauges[gauge], origin[1]+gauge_middle-gauge_range, 
																 6, gauge_range*2, tol);
		if pos then
			readings[gauge] = origin[1]+gauge_middle - pos[1];
		else
			-- couldn't find indicator
			readings[gauge] = gauge_range;
		end
		lsPrint(10, 15+15*gauge, 0, 0.7, 0.7, 0xFFFFFFff, "Gauge "..gauge..": "..readings[gauge]);
		
	end
	
	-- hopefully have gauge readings
	local button_vals = {};
	for button = 1,5 do
		button_vals[button] = 0;
		for _,gauge in ipairs(mapping[button]) do
			button_vals[button] = button_vals[button] + readings[gauge]^2;
		end
		lsPrint(10, 150+15*button, 0, 0.7, 0.7, 0xFFFFFFFF, "Button "..button.." value: "..button_vals[button]);
	end
	return button_vals;
end


function doit ()

	askForWindow("Put the window in focus, pin and load your crematory (and nothing else), and press Shift.");
	
	srReadScreen();
	
	local crematory = srFindImage("ThisIs.png", tol);
	
	
	local fire_button = srFindImageInRange("FireTheCrematory.png", crematory[0]-20, crematory[1], window_w, window_h, tol);
	if not fire_button then
		error("can't find fire button");
	end
	srClickMouseNoMove(fire_button[0]+5, fire_button[1]+2);
	lsSleep(250);
	
	-- find buttons (they always start black once the crematory is started)
	srReadScreen();
	local origin = srFindImageInRange("CrematoryButtons.png", crematory[0]-20, crematory[1], window_w, window_h, 100000);
	if not origin then
		error("can't find buttons in "..(crematory[0]-20).." "..crematory[1].." - "..(crematory[0]-20+window_w).." "..(crematory[1]+window_h));
	end
	
	local last_temps = getTemps(origin);
	lsSleep(25);
	while (isRed(srReadPixelFromBuffer(origin[0]+red_spot_x, origin[1]+red_spot_y))) do
	
		srReadScreen();
		
		local temps = getTemps(origin);
		
		for i = 1,5 do
			if (temps[i] > last_temps[i]) then
			
				-- should click button i
				srClickMouseNoMove(origin[0]+buttons[i], origin[1]+button_middle, 0);
				
			end
		
		end
		
		last_temps = temps;
		
		if lsButtonText(lsScreenX - 110, lsScreenY - 30, z, 100, 0xFFFFFFff, "End script") then
			error "Clicked End Script button";
		end
		
		checkBreak();
		lsDoFrame();
		lsSleep(25);
		
	end
	
end